/*
 * DynFunctionRegistry.h
 *
 *  Created on: Nov 29, 2010
 *      Author: Tobias Brosch
 */

#ifndef DYNFUNCTIONREGISTRY_H_
#define DYNFUNCTIONREGISTRY_H_

#include <string>
#include <map>
#include "Function.h"

class DynFunctionRegistry {
public:
	// constructors
	DynFunctionRegistry();
	DynFunctionRegistry(const std::string dirname);

	void add(Function* f);
	bool is_known(const std::string fname) const;
	Function* get_function(const std::string& fname);
private:
	const std::string dir;
	std::map<std::string, Function* > registry;
	Function* dynload(const std::string& fname);
};


#endif /* DYNFUNCTIONREGISTRY_H_ */
