#include <iostream>
#include "Function.h"
#include "DynFunctionRegistry.h"

int main() {
	DynFunctionRegistry registry("pluginFuncs");

	std::string fname;
	double x;

	while(std::cout << ": " && std::cin >> fname >> x) {
		if(registry.is_known(fname) || registry.get_function(fname)) {
			Function* f(registry.get_function(fname));
			std::cout << f->execute(x) << std::endl;
		} else {
			std::cout << "Unknown function name: " << fname << std::endl;
		}
	}

	return 0;
}
